#include <stdio.h>
#include <stdlib.h>

#include "lzw.h"
#include "bmp.h"
#include "fileio.h"
#include "mandel_calc.h"

/*

This code is copyright 2004 by Michael Kohn
You may not use any of this program in your own programs
without permission from Michael Kohn <mike@mikekohn.net>

*/

#ifdef ASM
int mandel_calc_asm(int *picture,struct mandelbrot_t *mandelbrot);
#endif

int main(int argc, char *argv[])
{
FILE *out;
unsigned int *picture;
struct mandelbrot_t mandelbrot;

  printf("\nMandel client test program\n");
  printf("Copyright 2004 - Michael Kohn <mike@mikekohn.net>\n\n");

  mandelbrot.width=640;
  mandelbrot.height=480;
  picture=(unsigned int *)malloc(mandelbrot.width*mandelbrot.height*sizeof(int));
  mandelbrot.real_start=-2.00;
  mandelbrot.real_end=1.00;
  mandelbrot.imaginary_start=-1.00;
  mandelbrot.imaginary_end=1.00;
  mandelbrot.count=100;

  mandelbrot.real_start=-0.74393;
  mandelbrot.real_end=-0.74382;
  mandelbrot.imaginary_start=-0.117093;
  mandelbrot.imaginary_end=-0.117017;

  if (picture!=0)
  {
#ifndef ASM
    mandel_calc(picture,&mandelbrot);
#else
    // mandel_calc_asm(picture,&mandelbrot);
    int t=mandel_calc_asm(picture,&mandelbrot);
    // printf("%x %x\n",t,(int)&mandelbrot);
    // printf("%x %x\n",t,(int)picture);
    printf("%d\n",t);
#endif

    out=fopen("debug.gif","wb");
    if (out!=0)
    {
      lzw_compress(out,picture,mandelbrot.width,mandelbrot.height);
      fclose(out);
    }

    out=fopen("debug.bmp","wb");
    if (out!=0)
    {
      write_bmp(out,picture,mandelbrot.width,mandelbrot.height);
      fclose(out);
    }
  }

  free(picture);

  return 0;
}



