#include <kernel.h>

#include "mandel_calc.h"

u32 mandel_calc(u32 *picture, struct mandelbrot_t *mandelbrot)
{
u32 x,y;
float r,i,r_step,i_step;
float tr,ti,zr,zi;
u32 ptr,count;
u32 colors[13];

  colors[0]=0x000033;
  colors[1]=0x000066;
  colors[2]=0x000099;
  colors[3]=0x0000aa;
  colors[4]=0x0033aa;
  colors[5]=0x0066aa;
  colors[6]=0x0099aa;
  colors[7]=0x339900;
  colors[8]=0x669900;
  colors[9]=0x999900;
  colors[10]=0x996600;
  colors[11]=0xaa3300;
  colors[12]=0xaa0000;

  r_step=(mandelbrot->real_end-mandelbrot->real_start)/(double)mandelbrot->width;
  i_step=(mandelbrot->imaginary_end-mandelbrot->imaginary_start)/(double)mandelbrot->height;
  ptr=0;

  i=mandelbrot->imaginary_start;

  for (y=0; y<mandelbrot->height; y++)
  {
    r=mandelbrot->real_start;

    for (x=0; x<mandelbrot->width; x++)
    {
      count=mandelbrot->count;
      zr=0;
      zi=0;

      while(count>0)
      {
        tr=((zr*zr)-(zi*zi));
        ti=(2*zr*zi);
        if ((tr*tr)+(ti*ti)>4) break;
        zr=tr+r;
        zi=ti+i;
        count--;
      }

      if (count==0) picture[ptr]=0;
        else
      { picture[ptr]=colors[(int)((float)12*((float)count/(float)mandelbrot->count))]; }

      ptr++;
      r=r+r_step;
    }

    i=i+i_step;
  }

  return 0;
}

